package zed;
// @author Spirolone
import java.io.*;

public class ZedToDataBin {
    
    public static void main(String[] args) {
        try{
            String FileName;
            if (args.length > 0)
                FileName = args[0];
            else
                FileName = "DATA_004";
            RandomAccessFile zedFile = new RandomAccessFile(FileName+".ZED", "r");
            // Read Offset and Size of Central Directory
            byte[] fileContent;
            zedFile.seek(zedFile.length()-8);
            zedFile.read(fileContent = new byte[8]);
            for (int i=7; i>0; i--)
                fileContent[i] ^= fileContent[i-1];
            fileContent[0] ^= fileContent[7];
            int centralDirOffset = ((fileContent[7] & 0xFF)<<24)|((fileContent[5] & 0xFF)<<16)|((fileContent[3] & 0xFF)<<8)|(fileContent[1] & 0xFF);
            // Read first 340 bytes of Central Directory
            byte[] filesHeadersFromData = new byte[340];
            zedFile.seek(centralDirOffset);
            zedFile.read(filesHeadersFromData);
            // Read fileHeaderA
            byte[] fileHeaderA = new byte[46];
            zedFile.seek(centralDirOffset + 541);
            zedFile.read(fileHeaderA);
            for (int i=45; i>0; i--)
                fileHeaderA[i] ^= fileHeaderA[i-1];
            fileHeaderA[0] = 0x50;
            // Read filesFromData
            byte[] filesFromData = new byte[(int)bytesToNum(fileHeaderA, 4, 42)];
            zedFile.seek(0);
            zedFile.read(filesFromData);
            // Read fileHeaderB
            byte[] fileHeaderB = new byte[36];
            zedFile.seek(centralDirOffset + 541 + 46 + bytesToNum(fileHeaderA, 2, 28));
            zedFile.read(fileHeaderB);
            for (int i=35; i>0; i--)
                fileHeaderB[i] ^= fileHeaderB[i-1];
            fileHeaderB[0] = 0x0A;
            // Correct some bytes
            fileHeaderA[38] = 0x30;     // External Attr.
            fileHeaderA[10] = 0;        // Compression
            System.arraycopy(new byte[4], 0, fileHeaderA, 16, 4);       // Crc-32
            System.arraycopy(new byte[4], 0, fileHeaderA, 20, 4);       // Compressed Size
            System.arraycopy(new byte[4], 0, fileHeaderA, 24, 4);       // Uncompressed Size
            System.arraycopy(new byte[2], 0, fileHeaderA, 28, 2);       // File Name Len
            System.arraycopy(new byte[4], 0, fileHeaderA, 42, 4);       // Offset
            // Write Data.bin
            (new File("Data.bin")).delete();
            RandomAccessFile data = new RandomAccessFile("Data.bin", "rw");
            data.write(filesFromData);
            data.write(filesHeadersFromData);
            data.write(fileHeaderA);
            data.write(fileHeaderB);
            data.close();
        }
        catch (Exception e){
            System.out.printf("Error");
        }
    }
    
    static long bytesToNum(byte[] bytesArray, int dim, int offset) {
        long num = 0;
        for (int i=0; i<dim; i++)
            num += (bytesArray[i+offset] & 0xFF)<<(8*i);
        return num;
    }
}