package zed;
// @author Spirolone
import java.io.RandomAccessFile;

public class ZipToZed {
    
    public static void main(String[] args) {
        try{
            // Files
            String FileName;
            if (args.length > 0)
                FileName = args[0];
            else
                FileName = "DATA_004";
            RandomAccessFile zipFile = new RandomAccessFile(FileName+".zip", "r");
            RandomAccessFile zedFile = new RandomAccessFile(FileName+".ZED", "r");
            RandomAccessFile zedNewFile = new RandomAccessFile(FileName+"_New.ZED", "rw");

            // Read Central Directory of Zip File
            byte[] fileContent;
            zipFile.seek(zipFile.length()-10);
            zipFile.read(fileContent = new byte[8]);
            int centralDirOffset = ((fileContent[7] & 0xFF)<<24)|((fileContent[6] & 0xFF)<<16)|((fileContent[5] & 0xFF)<<8)|(fileContent[4] & 0xFF);
            int centralDirSize = ((fileContent[3] & 0xFF)<<24)|((fileContent[2] & 0xFF)<<16)|((fileContent[1] & 0xFF)<<8)|(fileContent[0] & 0xFF);
            zipFile.seek(centralDirOffset);
            byte[] centralDir = new byte[centralDirSize];
            zipFile.read(centralDir);
            
            // Read first 340 Bytes of Central Directory of Original Zed File
            zedFile.seek(zedFile.length()-8);
            zedFile.read(fileContent = new byte[8]);
            for (int i=7; i>0; i--)
                fileContent[i] ^= fileContent[i-1];
            fileContent[0] ^= fileContent[7];
            centralDirOffset = ((fileContent[7] & 0xFF)<<24)|((fileContent[5] & 0xFF)<<16)|((fileContent[3] & 0xFF)<<8)|(fileContent[1] & 0xFF);
            zedFile.seek(centralDirOffset);
            byte[] centralDirHead = new byte[340];
            zedFile.read(centralDirHead);
            
            // Copy FileData.xml and Header.xml
            fileContent = new byte[8];
            for (int i=0; i<4; i++)
                fileContent[i] = (byte)(centralDirHead[257+i] ^ centralDirHead[258+i]);
            for (int i=0; i<4; i++)
                fileContent[4+i] = (byte)(centralDirHead[279+i] ^ centralDirHead[280+i]);
            int length = ((fileContent[3] & 0xFF)<<24)|((fileContent[2] & 0xFF)<<16)|((fileContent[1] & 0xFF)<<8)|(fileContent[0] & 0xFF);
            length += ((fileContent[7] & 0xFF)<<24)|((fileContent[6] & 0xFF)<<16)|((fileContent[5] & 0xFF)<<8)|(fileContent[4] & 0xFF);
            zedFile.seek(0);
            fileContent = new byte[length];
            zedFile.read(fileContent);
            zedNewFile.write(fileContent);
            
            int pt = 0;
            int localFileCompSize;
            int localFileOffset;
            int localFileNameLen;
            byte[] localFileData;
            while (pt < centralDirSize-1) {     //Scan Central Dir
                localFileCompSize = ((centralDir[pt+23] & 0xFF)<<24)|((centralDir[pt+22] & 0xFF)<<16)|((centralDir[pt+21] & 0xFF)<<8)|(centralDir[pt+20] & 0xFF);
                localFileNameLen = ((centralDir[pt+29] & 0xFF)<<8)|(centralDir[pt+28] & 0xFF);
                if (localFileCompSize > 0) {        // Not a Directory
                    localFileOffset = ((centralDir[pt+45] & 0xFF)<<24)|((centralDir[pt+44] & 0xFF)<<16)|((centralDir[pt+43] & 0xFF)<<8)|(centralDir[pt+42] & 0xFF);
                    localFileData = new byte[localFileCompSize];
                    zipFile.seek(localFileOffset+30+localFileNameLen);
                    zipFile.read(localFileData);
                    zedNewFile.write(localFileData);        // Wtite Local File
                }
                localFileOffset = (int)zedNewFile.getFilePointer() - localFileCompSize;     // New Local File Offset
                centralDir[pt+42] = (byte)(localFileOffset & 0xFF);
                centralDir[pt+43] = (byte)((localFileOffset>>8) & 0xFF);
                centralDir[pt+44] = (byte)((localFileOffset>>16) & 0xFF);
                centralDir[pt+45] = (byte)((localFileOffset>>24) & 0xFF);
                centralDir[pt+9] = 1;       // Set Flag
                pt += localFileNameLen + 82;
            }
            zipFile.close();

            // Write first 340 Bytes of Central Directory
            centralDirOffset = (int)zedNewFile.getFilePointer();       // New Central Directory Offset
            zedNewFile.write(centralDirHead);
            zedFile.seek(zedFile.length()-10);
            centralDir[centralDirSize-1] = (byte)(zedFile.read() ^ zedFile.read());
            zedFile.close();
            // Xor
            centralDir[0] ^= centralDirHead[339];
            for (int i=1; i<centralDirSize; i++)
                centralDir[i] ^= centralDir[i-1];
            // Write rest of Central Directory
            zedNewFile.write(centralDir);
            // Write last 8 Bytes
            centralDirSize += 340;       // New Central Directory Size
            fileContent = new byte[8];
            fileContent[0] = (byte)(centralDirSize & 0xFF);
            fileContent[2] = (byte)((centralDirSize>>8) & 0xFF);
            fileContent[4] = (byte)((centralDirSize>>16) & 0xFF);
            fileContent[6] = (byte)((centralDirSize>>24) & 0xFF);
            fileContent[1] = (byte)(centralDirOffset & 0xFF);
            fileContent[3] = (byte)((centralDirOffset>>8) & 0xFF);
            fileContent[5] = (byte)((centralDirOffset>>16) & 0xFF);
            fileContent[7] = (byte)((centralDirOffset>>24) & 0xFF);
            fileContent[0] ^= fileContent[7];
            for (int i=1; i<8; i++)
                fileContent[i] ^= fileContent[i-1];
            zedNewFile.write(fileContent);
            zedNewFile.close();
        }
        catch (Exception e){
            System.out.printf("Error");
        }
    }
}